aUF_AutoHide = AceLibrary("AceAddon-2.0"):new("AceDB-2.0","AceEvent-2.0","AceHook-2.1","AceDebug-2.0")

local defaultProfile = {
	frames = { ["*"] = false }
}

function aUF_AutoHide:OnInitialize()
	self:RegisterDB("aUF_AutoHideDB")
	self:RegisterDefaults('profile', defaultProfile)

	self.core = aUF
	self.coreOptions = self.core.mainMenu.args
end

function aUF_AutoHide:OnEnable()	
	self:RegisterEvent("PLAYER_REGEN_DISABLED", "UpdateCombat")
	self:RegisterEvent("PLAYER_REGEN_ENABLED", "UpdateCombat")
	for frames in pairs(self.db.profile.frames) do
		local parent = self.core.units[frame]
		if parent then	
			self:SecureHook(parent, "UpdateHealth", "UpdateFrame")
		end
	end
	self:UpdateCombat()
	self:UpdateOptions()
end

function aUF_AutoHide:UpdateCombat()
    for frame in pairs(self.db.profile.frames) do
		local parent = self.core.units[frame]
		if parent then
			self:UpdateFrame(parent)
		end
    end
end

function aUF_AutoHide:UpdateFrame(parent)
	local frame = parent.frame:GetName()
	local currValue,maxValue = UnitHealth(parent.unit),UnitHealthMax(parent.unit)
	if UnitAffectingCombat("player") or (currValue ~= maxValue) then
    	self:Debug("Show",frame)
    	parent.frame:SetAlpha(1)
	else 
    	self:Debug("Hide",frame)
    	parent.frame:SetAlpha(0)
	end
end

function aUF_AutoHide:UpdateOptions()
	local optionArgs = self.coreOptions
	optionArgs.aUF_AutoHide = {
		name = self.name,
		desc = self.name,
		type = "header",
		order = 201,
	}
	optionArgs.aUF_AutoHide_toggleUnit = {
	    name = "Auto-Hide Units",
	    desc = "Auto-Hide Units",
	    type = "text",
	    get = function(frame) return self.db.profile.frames[frame] end,
	    set = function(frame,v)
			self.db.profile.frames[frame] = v
			local parent = self.core.units[frame]
			if v then
				self:SecureHook(parent, "UpdateHealth", "UpdateFrame")
				self:UpdateFrame(parent)
			else
    			if parent then
					parent.frame:SetAlpha(1)
				end
				self:Unhook(parent, "UpdateHealth")
			end
		end,
	    multiToggle = true,
	    validate = {},
	    order = 202
	}
	for unit in pairs(self.core.units) do
	    optionArgs.aUF_AutoHide_toggleUnit.validate[unit] = unit
	end	
end